// Friendly Class
// Mainly used for helpful NPCs, objects to pick up , bonusses etc
// MY CHYE - Abertay Dundee Uni 2009

#include "Friendly.h"
#include <stdio.h> 
#define RADIUS 3; // How far the object's radius is (for detection)

Friendly::Friendly(DSoundDevice *dsDevice, int MaxX, int MinX, int MaxZ, int MinZ, float range)
{
	theDevice = dsDevice;
	theDevice->CreateSoundBuffer(&beep, "beep1.wav", DSBCAPS_CTRL3D);
	beep3d = beep->Get3dBuffer();
	alive = true;	
	// Gets a random value within the range
	//little tweak so it wont spawn to close to the walls
	static int tempX = ((MaxX-(rand()%3+1)) - (MinX+(rand()%3+1)));
	static int tempZ = ((MaxZ-(rand()%3+1)) - (MinZ+(rand()%3+1)));
	static int finalX = tempX; //little tweak so it wont spawn to close to the walls
	static int finalZ = tempZ;	
	X = rand()%finalX - MaxX;
	Z = rand()%finalZ - MaxZ;	
	beep3d = beep->Get3dBuffer();
	rad = range;
	beep3d->SetPosition(X, 0, Z, DS3D_IMMEDIATE);
}

Friendly::~Friendly()
{
	if(beep) free(beep);
	if(beep3d) beep3d->Release();
	beep = NULL;
	beep3d = NULL;
}

void Friendly::PrintDebug(int i)
{
	if(alive)
	{
		printf("\nPosition of Medikit : %d is  : X: %d, Z: %d", i , X, Z);	
		
	}
}

void Friendly::Dead()
{
	if(alive)
	{
		if(beep->IsPlaying())beep->Stop();
		alive = false;
	}
}

void Friendly::Alive()
{
	static int count  = 120;
	static bool played = false;
	if(alive)
	{
		if(!played)
		{
			if(!beep->IsPlaying())beep->Play();
			//beep->ChangeVolume(tempVol);
			played = true;
		}
		if(count == 0)
		{ played = false;
		count = 120;
		}
		count--;
	}
}

void Friendly::StopAllSound()
{
	if(beep->IsPlaying())beep->Stop();
}

void Friendly::Near()
{
	static int count  = 10;
	static bool played = false;
	if(alive)
	{
		if(!played)
		{
			if(!beep->IsPlaying())beep->Play();
			played = true;
		}
		if(count == 0)
		{ played = false;
		count = 10;
		}
		count--;
	}
}


int Friendly::GetX()
{
	return X;
}

int Friendly::GetZ()
{
	return Z;
}

float Friendly::GetRad()
{
	return rad;
}

bool Friendly::GetStatus()
{
	return alive;
}