// Game Class
// Heart and soul of the game
// MY CHYE - Abertay Dundee Uni 2009

#include "Game.h"
#define MAX_MEDIKITS NUM_ZOMBIES // NUM_ZOMBIES must be 5 in this game because of the audio score function in GameOver()
#define ZOMBIEREACH 4 // zombie reach radius (remember zombie will have 1.5*radius for suspicious zone)
#define ZOMBIEFOV 100 // zombie fov detection angle (in degrees)
#define ZOMBIEATTKSPEED 200 // the zombie attack speed 180 is roughly a hit in 3 seconds
#define PLAYER_LIFE 3// how many lifes the player has
#define RANGE  4// how far can you pick up the medikit (medikit's radius)


int medkit; // how many medikits the player have
bool timer(float sec); // how long the game runs
int zombiekilled; // how many zombies killed for cool audio counter in GameOver()
bool entered; // for QUIT()


Game::Game(DSoundDevice* device) // All the sounds needed for game is loaded here
{
	srand ( time(NULL) ); // Seed the random number generator
	theDevice = device;
	player = new Player(device, PLAYER_LIFE);
	// General Sound effects
	theDevice->CreateSoundBuffer(&IntroSpeech, "instructions.wav", DSBCAPS_CTRL3D);	
	theDevice->CreateSoundBuffer(&pickMedkit, "medipickedup.wav", DSBCAPS_CTRL3D);	
	pickMedkit3d = pickMedkit->Get3dBuffer();	
	theDevice->CreateSoundBuffer(&noMedleft, "nomedileft.wav", DSBCAPS_CTRL3D);	
	noMedleft3d = noMedleft->Get3dBuffer();
	theDevice->CreateSoundBuffer(&noZombie, "nozombie.wav", DSBCAPS_CTRL3D);	
	noZombie3d = noZombie->Get3dBuffer();
	theDevice->CreateSoundBuffer(&savedOne, "saved1.wav", DSBCAPS_CTRL3D);	
	savedOne3d = savedOne->Get3dBuffer();
	theDevice->CreateSoundBuffer(&dead, "playerdead.wav", DSBCAPS_CTRL3D);	
	dead3d = savedOne->Get3dBuffer();
	theDevice->CreateSoundBuffer(&timeup, "timesup.wav", DSBCAPS_CTRL3D);	
	timeup3d = timeup->Get3dBuffer();
	theDevice->CreateSoundBuffer(&gameover, "gameover1.wav", DSBCAPS_CTRL3D);		
	theDevice->CreateSoundBuffer(&nozombies, "nozombies.wav", DSBCAPS_CTRL3D);	
	theDevice->CreateSoundBuffer(&onezombie, "onezombie.wav", DSBCAPS_CTRL3D);
	theDevice->CreateSoundBuffer(&twozombies, "twozombies.wav", DSBCAPS_CTRL3D);
	theDevice->CreateSoundBuffer(&threezombies, "threezombies.wav", DSBCAPS_CTRL3D);
	theDevice->CreateSoundBuffer(&fourzombies, "fourzombies.wav", DSBCAPS_CTRL3D);
	theDevice->CreateSoundBuffer(&allzombies, "allzombies.wav", DSBCAPS_CTRL3D);

	// Environmental Sounds
	theDevice->CreateSoundBuffer(&fire, "fire.wav", DSBCAPS_CTRL3D);	
	fire3d = fire->Get3dBuffer();
	theDevice->CreateSoundBuffer(&water, "waterdrop.wav", DSBCAPS_CTRL3D);	
	water3d = water->Get3dBuffer();
	theDevice->CreateSoundBuffer(&wind, "windchime1.wav", DSBCAPS_CTRL3D);	
	wind3d = wind->Get3dBuffer();

	fire3d->SetPosition(player->GetMaxX()-3, 0, 0, DS3D_IMMEDIATE); // fire environmental sound near the West wall
	water3d->SetPosition(player->GetMinX()+3, 0, player->GetMinZ()+3, DS3D_IMMEDIATE); // water environmental sound near the South East wall
	wind3d->SetPosition(0, 0, player->GetMaxZ()-3, DS3D_IMMEDIATE); // windchime environmental sound near the north wall

	for(int i =1; i<=NUM_ZOMBIES; i++)
	{
		zombie[i] = new Enemy(device);
		
	}
	// spawn Medikits at random locations within the player's boundary
	for(int i=1;i<=MAX_MEDIKITS;i++)
	{
		medikit[i] = new Friendly(theDevice, player->GetMaxX(), player->GetMinX(), player->GetMaxZ(), player->GetMinZ(), RANGE);
	}
	pickup = false;
	medkit = 0;
	zombiekilled = 0;
	entered = false;
	

}

Game::~Game()
{	
	if (IntroSpeech)   free (IntroSpeech);
	IntroSpeech = NULL;
	if (pickMedkit) free (pickMedkit);
	if (pickMedkit3d) pickMedkit3d->Release();
	pickMedkit = NULL;
	pickMedkit3d = NULL;	
	if (noMedleft) free (noMedleft);
	noMedleft = NULL;
	if (noMedleft3d) noMedleft3d->Release();
	noMedleft3d = NULL;
	if (noZombie) free (noZombie);
	noZombie = NULL;
	if (noZombie3d) noZombie3d->Release();
	noZombie3d = NULL;
	if (savedOne) free (savedOne);
	savedOne = NULL;
	if (savedOne3d) savedOne3d->Release();
	savedOne3d = NULL;
	if (fire) free (fire);
	if (fire3d) fire3d->Release();
	fire = NULL;
	fire3d = NULL;
	if (wind) free (wind);
	if (wind3d) wind3d->Release();
	wind = NULL;
	wind3d = NULL;
	if (water) free (water);
	if (water3d) water3d->Release();
	water = NULL;
	water3d = NULL;
	if(timeup) free (timeup);
	if (timeup3d) timeup3d->Release();
	timeup = NULL;
	timeup3d = NULL;
	if (dead) free (dead);
	if (dead3d) dead3d->Release();
	dead = NULL;
	dead3d = NULL;
	if (gameover) free (gameover);	
	gameover = NULL;
	/*if(allzombies) free (allzombies);
	allzombies = NULL;*/
	if(nozombies) free (nozombies);
	nozombies = NULL;
	if(onezombie) free (onezombie);
	onezombie = NULL;
	if(twozombies) free (twozombies);
	twozombies = NULL;
	if(threezombies) free (threezombies);
	threezombies = NULL;
	if(fourzombies) free (fourzombies);
	fourzombies = NULL;	
	Quit();
}


bool Game::Init()
{
	for(int i =1; i<=NUM_ZOMBIES; i++)
	{
		zombie[i]->Init(player->GetMaxX(), player->GetMinX(), player->GetMaxZ(), player->GetMinZ(), ZOMBIEREACH, ZOMBIEATTKSPEED);	
		
	}
	player->Reset();
	zombiekilled = 0;
	GameState = INTRO;	
	return true;
}


void Game::GameLoop()
{
	switch (GameState)
	{
	case INTRO:			
		GameIntro();
		break;

	case GAME:	
		GameMain();
		break;			
	case GAMEOVER:			
		GameEnd();
		break;				

	default:
		//printf("Undefined Game State\n");
		break;
	}	
}

void Game::GameIntro()
{

	//Environmental Sound
	//Unlikely they will play now but just to make sure
	if(fire->IsPlaying())fire->Stop();
	if(water->IsPlaying())water->Stop();
	if(wind->IsPlaying())wind->Stop();

	// All these if player replays (save the trouble of destroying and recreatin buffers
	zombiekilled = 0;

	// Just respwawn those dead ones at different locations 
	for(int i =1; i<=NUM_ZOMBIES; i++)
	{
		if(!zombie[i]->GetStatus())
		{
			zombie[i]->Init(player->GetMaxX(), player->GetMinX(), player->GetMaxZ(), player->GetMinZ(), ZOMBIEREACH, ZOMBIEATTKSPEED);
			
		}
	}

	// spawn new medikits if any picked up
	for(int j=1;j<=MAX_MEDIKITS;j++)
	{
		if(!medikit[j]->GetStatus()) // if no medikit alive
			medikit[j] = new Friendly(theDevice, player->GetMaxX(), player->GetMinX(), player->GetMaxZ(), player->GetMinZ(), RANGE);
	}


	static bool played = false;
	if(!played)
	{
		played = true;
		IntroSpeech->Play();
	}

	// A little trick so that user don't accidently click out of the window
	int midScrX = GetSystemMetrics(SM_CXSCREEN) >> 1;
	int midScrY = GetSystemMetrics(SM_CYSCREEN) >> 1;
	SetCursorPos(midScrX, midScrY); 

	static int count = 250;
	static bool repeat = false;
	if(!repeat)
	{
		if(!IntroSpeech->IsPlaying())IntroSpeech->Play();
		repeat = true;
	}
	if(count ==0)
	{
		repeat = false;
		count = 250;
	}
	count--;

	if (GetAsyncKeyState (VK_SPACE) & 0x0001) GameState =GAME;	
}

void Game::GameMain()
{
	if(!timer(80) || zombiekilled == NUM_ZOMBIES) // How many seconds to run the game (around a min)
	{

		//Environmental Sound
		if(!fire->IsPlaying())fire->Play(DSBPLAY_LOOPING);
		if(!water->IsPlaying())water->Play(DSBPLAY_LOOPING);
		if(!wind->IsPlaying())wind->Play(DSBPLAY_LOOPING);

		if(IntroSpeech->IsPlaying())IntroSpeech->Stop();	
		player->MouseInput();

		for(int j = 1;j<=MAX_MEDIKITS;j++)
		{
			medikit[j]->Alive();
			if (player->BoundingCircle(medikit[j]->GetX(), medikit[j]->GetZ(), medikit[j]->GetRad()))
			{
				if(medikit[j]->GetStatus())	medikit[j]->Near(); // beep faster if player gets near 
			}
		}

		for(int i =1; i<=NUM_ZOMBIES; i++)
		{
			if(zombie[i]->GetStatus()) // don't check if the particular zombie is already dead
			{
	
				// player outside the suspicious zone and also the fov attack zone
				if(player->BoundingCircle(zombie[i]->GetX(), zombie[i]->GetZ(), zombie[i]->GetRad()+2) == false
					&& player->BoundingCircle(zombie[i]->GetX(), zombie[i]->GetZ(), zombie[i]->GetRad()) == false) // outside the fov attack zone


				{
					//printf("In NORMAL for %d\n\n", i);
					//if(player->GetLife()<PLAYER_LIFE)player->SetLife(PLAYER_LIFE); // Player back to full life
					zombie[i]->Normal();
					entered = true; // for Game::Quit()	
					
				}
				// if player inside the suspicious zone 
				if(player->BoundingCircle(zombie[i]->GetX(), zombie[i]->GetZ(), zombie[i]->GetRad()+2) == true 
					&& player->BoundingCircle(zombie[i]->GetX(), zombie[i]->GetZ(), zombie[i]->GetRad()) == false)//but still outside the fov attack zone
				{
					zombie[i]->Suspicious();	
					printf("in SUSPICIOUS for %d\n\n", i);
					if (GetAsyncKeyState (VK_RBUTTON) & 0x0001) 
					{
						if(medkit<=0) // Is there medkit?
						{
							noMedleft3d->SetMode(DS3DMODE_HEADRELATIVE, DS3D_IMMEDIATE);
							if(!noMedleft->IsPlaying())noMedleft->Play();
						}
					
						// Is player in suspicious zone and zombie not attackin?
						else
							
							// if(player->Attacked(zombie[i]->GetX(), zombie[i]->GetZ(), zombie[i]->GetRad(), zombie[i]->Return2Dpos(), zombie[i]->Return2DOrient(), ZOMBIEFOV ) == false) // not attacking?
						{
							printf("Zombie %d dies\n\n", i);
							zombiekilled++;
							savedOne3d->SetMode(DS3DMODE_HEADRELATIVE, DS3D_IMMEDIATE);
							if(!savedOne->IsPlaying())savedOne->Play();
							Sleep(1000);
							zombie[i]->Die();						
							medkit--;
							Sleep(1000); // Just so the Die sound plays in full
							
						}				
					}

					
					
				}
				// if player is in attack zone and also if zombie faces him				
				if(player->Attacked(zombie[i]->GetX(), zombie[i]->GetZ(), zombie[i]->GetRad(), zombie[i]->Return2Dpos(), zombie[i]->Return2DOrient(), ZOMBIEFOV )) 
				{
					static bool alive = true;
					//printf("IN ATTACK for %d\n\n", i);					
					
					if(alive)
					{
						zombie[i]->Attack();
						//printf("Zombie attacking/facing you!!!\n\n\n");
						player->LifeCounter(zombie[i]->GetAttackSpeed());		
						//player->SetLife(player->GetLife()-1);
					}

					if(!player->CheckAlive())
					{
						player->stopWalkSound();
						alive = false;
						Sleep(2700);
						zombie[i]->StopAllSound();
						//attack = false; // no more attackin (used to check if go enemy->Normal()
						dead3d->SetMode(DS3DMODE_HEADRELATIVE, DS3D_IMMEDIATE);
						if(!dead->IsPlaying())dead->Play();
						Sleep(3500);
						GameState = GAMEOVER;	
					}
				}
			}

		}
		// Check if keys were pressed since last key state call - least significant bit.
		if (GetAsyncKeyState (VK_SPACE) & 0x0001) 
		{	
			//printf("\nSpace pressed\nResetting\n\n");	
			player->PrintDebug();
		//	player->Reset();	
			// Print debug information for zombie and medikits
			for(int i=1;i<=NUM_ZOMBIES;i++)
			{
				if(zombie[i]->GetStatus()){

					printf("Zombie %d X orient : %d Z orient : %d\n",i, zombie[i]->GetOrX(), zombie[i]->GetOrZ());
					printf("Zombie %d Position X : %d Position Y : %d\n", i, zombie[i]->GetX(), zombie[i]->GetZ());
				}
			}
			for(int i=1;i<=MAX_MEDIKITS;i++)medikit[i]->PrintDebug(i);
			printf("\nMedikits on player: %d\n", medkit);
		}		

		if (GetAsyncKeyState (VK_LEFT) & 0x0001 ) {
			player->move(Player::eLeft, kMoveAmt);
			player->playWalkSound();
		}

		if (GetAsyncKeyState (VK_LSHIFT) & 0x0001 ) {
			printf("Current Lives: %d\n\n", player->GetLife());
			player->PrintDebug();
			player->FaceNorth();
		}

		if (GetAsyncKeyState (VK_RIGHT) & 0x0001 ) 
		{
			player->move(Player::eRight, kMoveAmt);
			player->playWalkSound();			
		}

		if (GetAsyncKeyState (VK_UP) & 0x0001)
		{
			player->move(Player::eForward, kMoveAmt);		
			player->playWalkSound();		
		}

		if (GetAsyncKeyState (VK_DOWN) & 0x0001 ) 
		{
			player->move(Player::eBack, kMoveAmt);
			player->playWalkSound();		
		}	

		// Check if player is trying to pickup the medikits
		if (GetAsyncKeyState (VK_LBUTTON) & 0x0001) // is Left mouse button clicked?
		{
			//check if player is in boundary of medikit and tries to pick it up
			for(int i = 1;i<=MAX_MEDIKITS;i++)
			{
				if(player->BoundingCircle(medikit[i]->GetX(), medikit[i]->GetZ(), medikit[i]->GetRad()) && medikit[i]->GetStatus())
				{
					medikit[i]->Dead(); // kills that medikit
					printf("\nMedikit : %d taken!\n\n", i);
					//pickMedkit3d->SetPosition(player->GetX(), 0, player->GetZ(), DS3D_IMMEDIATE);
					pickMedkit3d->SetMode(DS3DMODE_HEADRELATIVE, DS3D_IMMEDIATE);
					if(!pickMedkit->IsPlaying())pickMedkit->Play();
					if(medkit<MAX_MEDIKITS)medkit++;

				}
			}
		}		
	}
	else 
	{
		timeup3d->SetMode(DS3DMODE_HEADRELATIVE, DS3D_IMMEDIATE);
		if(!timeup->IsPlaying())timeup->Play();
		Sleep(1500);
		GameState = GAMEOVER;
	}	
}

void Game::GameEnd()
{
	//Environmental Sound
	//Unlikely they will play now but just to make sure
	if(fire->IsPlaying())fire->Stop();
	if(water->IsPlaying())water->Stop();
	if(wind->IsPlaying())wind->Stop();
	if(dead->IsPlaying())dead->Stop();

	for(int i =1; i<=NUM_ZOMBIES; i++)
	{
		zombie[i]->KillAll();
	}
	// stop any medikit sound (in preparing to go intro again)
	for(int i=1;i<=MAX_MEDIKITS;i++)
	{
		medikit[i]->StopAllSound();
	}

	static bool resetok = false;

	if(!resetok)
	{
		resetok = true;
		player->Reset(); // Hopefully I dont need 3d sound buffers then
	}

	static bool played = false;
	static int count = 300;
	if(!played)
	{
		if(!gameover->IsPlaying())gameover->Play();
		Sleep(2200); //slight pause before announcing how many zombies rescued
		//cool audio zombie rescued counter!
		if(zombiekilled == NUM_ZOMBIES) allzombies->Play();
		else if(zombiekilled == 0) nozombies->Play();
		else if(zombiekilled == 1) onezombie->Play();
		else if(zombiekilled == 2) twozombies->Play();
		else if (zombiekilled == 3) threezombies->Play();
		else if (zombiekilled == 4) fourzombies->Play();
		played = true; // have to wait a while till repeating this
	}
	if(count == 0) 
	{
		played = false;
		count = 300; // wait a while before repeating Game Over announcement
	}

	count--;
	if (GetAsyncKeyState (VK_SPACE) & 0x0001)
	{
		if(gameover->IsPlaying())gameover->Stop();
		Sleep(1000);
		GameState = INTRO;
	}	
}

void Game::Quit()
{
	if(entered)
	{
		delete zombie[NUM_ZOMBIES];
		delete medikit[MAX_MEDIKITS];
		delete player;
	}
}

bool timer(float sec)  //simple countdown timer in seconds - this assumes a 60fps lock
{
	static bool once = false;

	if(!once)
	{
		printf("\nGameStarted!!!\n");
		once = true;
	}
	static float frame = (60*sec)/2;
	/*frame--;
	static float temp = 0;
	printf("\n Countdown : %f", temp);*/
	if (frame <= 0)
	{
		printf("\nTime's Up\n\n");
		Sleep(150);
		return true;
	}
	frame--;
	//temp = (frame/60)*2;
	return false;
}
