// main.cpp - application file
// MY CHYE - Abertay Dundee Uni 2009


//#include "dsoundUtility.h"
#include "Game.h"
//#include "SoundManager.h"
//#include "Player.h"
#include <stdio.h> 
#include <time.h>
#include <stdlib.h>

//--- Globals.
//--- Program-wide resource declarations.
DSoundDevice* dsDevice     = NULL;  
Game* newGame;

//--- Framework Functions

//--- Set up soundscape 3D buffers and the turning head.
//--- Returns false if error detected.
bool Setup()
{
	srand( (unsigned)time( NULL ) );
	newGame = new Game(dsDevice);
	newGame->Init();
	return true;
}


//--- Clean up and release the sound resources.
void Cleanup()
{
	delete newGame;
	// for debug
	fclose(stdout);
	FreeConsole();
}

bool Process (float timeDelta)
{

	// CREATE CONSOLE
	AllocConsole();
	freopen("CONOUT$", "wb", stdout);
	// END OF DEBUG CONSOLE
	newGame->GameLoop();
	return true;
}


//--- The Windows message handler.
//--- Escape key terminates application.
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch( msg )
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_KEYDOWN: // If we get a key down message, do stuff

			switch(wParam)
			{
				case VK_ESCAPE: // If they push ESC, close the app
					DestroyWindow(hwnd);
						break;		
			}
	}
	return DefWindowProc(hwnd, msg, wParam, lParam);
}


//--- Application entry point.
//--- calls the framework functions.
//--- Sets up Directsound.
int WINAPI WinMain(HINSTANCE hinstance,
				   HINSTANCE prevInstance, 
				   PSTR cmdLine,
				   int showCmd)
{
	HWND hwnd;   // handle to window  created.
	
	if (!InitWindow (
		"2009 DirectX Audio Coursework",  
		hinstance,
		800, 600, false, 
		&hwnd))       // returns window handle.
	{
		MessageBox(0, "InitWindow() - FAILED", 0, 0);
		return 0;
	}

	//--- Initialise DirecSound.
	dsDevice = new DSoundDevice();
	if (!dsDevice->Initialize (hwnd, DSSCL_PRIORITY))
	{
		MessageBox(0, "DSoundDevice::Initialize() - FAILED", 0, 0);
		return 0;	
	}

	//--- call the setup function and test if it worked.
	if(!Setup())
	{
		MessageBox(0, "Setup() - FAILED", 0, 0);
		return 0;
	}

	//--- set up the 'process' function as the message loop handler.
	
	 EnterMsgLoop (Process);
	

	//--- do the cleaning up of resources before end of app.
	Cleanup();

	//--- clean-up DirectSound device.
	free (dsDevice);   // implicitly calss destructor method.
	ShowCursor(TRUE);
	return 0;
}

